/*PREPARACI DE LA DB*/
/*
A continuaci es crea el tablespace TFGmfabregaro. Est lligat al fitxer
de dades 'tfgmfabregaro.dat', amb una grandria inicial de 10 MB, 
ampliable fins a 500MB
*/
CREATE TABLESPACE TFGmfabregaro 
DATAFILE 'tfgmfabregaro.dat'
SIZE 10M
REUSE
AUTOEXTEND ON NEXT 10M MAXSIZE 500M;*/

//alter session set "_ORACLE_SCRIPT"=true;

/*
Es crea l'usuari mfabregaro amb contrassenya abc1234, que treballar
al tablespace creat anteriorment TFGmfabregaro. El seu tablespace
temporal ser TEMP*/
CREATE USER mfabregaro
IDENTIFIED BY abc1234
DEFAULT TABLESPACE TFGmfabregaro
TEMPORARY TABLESPACE TEMP;

/*Assignar els permisos necessaris a l'usuari creat: crear sessi,
usuaris, taules, etc.*/
GRANT CREATE SESSION, CREATE USER, 
CREATE TABLE, CREATE VIEW, CREATE TRIGGER, 
CREATE SEQUENCE TO mfabregaro;
grant create procedure to mfabregaro;
