/**************************************************************************/
/*PROVA CREATEBATCHPERSON, MODIFYPERSON, DROPPERSON
/*Crea 30 registres a la taula Person i una entrada al log
/**************************************************************************/
delete from person;
delete from logtable;
select * from person;
select * from logtable;

DECLARE
    RSP VARCHAR(200);
BEGIN
    CREATEBATCHPERSON(1, RSP);
    DBMS_OUTPUT.put_line(RSP);
END;

DECLARE
    RSP VARCHAR(200);
BEGIN
    modifyPerson('P30', 'NIF30M', 'Rey modif', 'Hitchcock Modif', '04/04/1999' , 'Male', rsp);
    DBMS_OUTPUT.put_line(RSP);
    dropPerson('P30', RSP);
    DBMS_OUTPUT.put_line(RSP);
END;

select * from person;
select * from logtable;

/**************************************************************************/
/*PROVA CREATECHANGEMANAGER
/*Crea el change manager de l'empresa
/*valida les restriccions d'integritat i/o proves necess�ries
/*Crea entrades al log
/**************************************************************************/
delete from membergcab;
delete from logtable;
select * from membergcab;
select * from logtable;

DECLARE
    RSP VARCHAR(200);
BEGIN
    --check crear gestor canvis i substitut que no existeixen a Person (error)
    CREATECHANGEMANAGER('P50', 'P51', RSP);
    DBMS_OUTPUT.put_line(RSP);
     --Gestor canvis i substitut son iguals (error)
    CREATECHANGEMANAGER('P1', 'P1', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --Gestor canvis i substitut que existeixen a Person
    CREATECHANGEMANAGER('P1', 'P2', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --Gestor de canvis ja existeix (error)
    CREATECHANGEMANAGER('P3', 'P4', RSP);
    DBMS_OUTPUT.put_line(RSP);
END;

select * from membergcab;
select * from logtable;
/**************************************************************************/
/*PROVA CREATEBATCHMEMBERGCAB, MODIFYMEMBERGCAB, DROPMEMBERGCAB
/*Crea registres a la taula MemberGCAB massivament i una entrada al log
/**************************************************************************/
delete from membergcab where rolegcab <> 'CM';
delete from logtable;
select * from membergcab;
select * from logtable;

--createbatchmembers
DECLARE
    RSP VARCHAR(200);
BEGIN
    CREATEBATCHMEMBERGCAB(3, RSP);
    DBMS_OUTPUT.put_line(RSP);    
END;

-- Modify i drop membergcab
DECLARE
    RSP VARCHAR(200);
BEGIN
    --creem batch persones
    CREATEBATCHPERSON(30, RSP); DBMS_OUTPUT.put_line(RSP);   
    --assignem a gcab massivament
    CREATEBATCHMEMBERGCAB(23, RSP); DBMS_OUTPUT.put_line(RSP); 
    --modifiquem membre P41
    MODIFYMEMBERGCAB('P41', 'TM', 'P43', RSP); DBMS_OUTPUT.put_line(RSP); 
    --eliminem membre P41
    DROPMEMBERGCAB('P41', RSP); DBMS_OUTPUT.put_line(RSP); 

END;

select * from membergcab ;
select * from logtable;
/**************************************************************************/
/*PROVA CREATEAPP
/*Crea registres a la taula AppInventory i una entrada al log
/**************************************************************************/
delete from geoareaapp;
delete from appinventory;
delete from logtable;
select * from geoareaapp;
select * from appinventory;
select * from logtable;
select * from membergcab ;


DECLARE
    RSP VARCHAR(200);
BEGIN
    --Error: sense area geografica valida
    CREATEAPP('E1',  'error 1 app', '15/03/20', 'tech', 'infra', 10000, 2, 'P3', 'P5', 
                 'test', 'test', 'test', 'test', RSP);
    --Error: Responsable tecnic invalid
     CREATEAPP('E2',  'primera app', '15/03/20', 'tech', 'infra', 10000, 2, 'PA', 'P5', 
                 'Europa', 'Asia', 'Oceania', 'America', RSP);
    --Error: Responsable de negoci invalid
     CREATEAPP('E3',  'primera app', '15/03/20', 'tech', 'infra', 10000, 2, 'P3', 'PB', 
                 'Europa', 'Asia', 'Oceania', 'America', RSP);
    --Creacio d'apps correctament
    --app amb impactoos Low
    CREATEAPP('A1',  'primera app', '15/03/20', 'tech', 'infra', 10000, 2, 'P3', 'P5', 
                 'Europa', 'Asia', 'Oceania', 'America', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --app amb impactoos Low
    CREATEAPP('A2',  'segona app', '15/04/21', 'tech', 'infra', 10000, 2, 'P7', 'P9', 
                 'Europa', '', '', '', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --app amb impactoos Medium
    CREATEAPP('A3',  'tercera app', '15/01/22', 'tech', 'infra', 70000, 6, 'P11', 'P13', 
                 'Europa', 'Asia', 'Oceania', 'America', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --app amb impactoos Medium
    CREATEAPP('A4',  'quarta app', '15/06/22', 'tech', 'infra', 60000, 5, 'P15', 'P17', 
                'Europa', 'Asia', 'Oceania', 'America', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --app amb impactoos high
    CREATEAPP('A5',  'cinquena app', '15/06/23', 'tech', 'infra', 700000, 10, 'P19', 'P21', 
                 'Europa', 'Asia', 'Oceania', 'America', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --app amb impactoos High
    CREATEAPP('A6',  'sisena app', '04/12/23', 'tech', 'infra', 200000, 2, 'P19', 'P21', 
                 '', 'Asia', '', '', RSP);
    DBMS_OUTPUT.put_line(RSP);
    CREATEAPP('A7',  'setena app', '04/12/20', 'tech', 'infra', 80000, 5, 'P19', 'P21', 
                 '', 'Asia', 'Oceania', '', RSP);
    DBMS_OUTPUT.put_line(RSP);
    
END;
--delete from appinventory where idapp = 'A7';
--DELETE FROM GEOAREAAPP WHERE IDAPP = 'A7';
select * from appinventory;
select * from logtable;
select * from geoareaapp;

/**************************************************************************/
/*PROVA MODIFYAPP I DROPAPP
/**************************************************************************/
DECLARE
    RSP VARCHAR(200);
BEGIN
    CREATEAPP('A8',  'vuitena app', '04/12/20', 'tech', 'infra', 80000, 5, 'P19', 'P21', 
                 '', 'Asia', 'Oceania', '', RSP);
    DBMS_OUTPUT.put_line(RSP);
    modifyApp('A8',  'modif', '04/01/2010', 'tech modif', 'infra modif', 60000, 5, 'P3', 'P5', 'Europa', '', '', 'America', RSP); 
    DBMS_OUTPUT.put_line(RSP);
    dropApp('A8', RSP);
    DBMS_OUTPUT.put_line(RSP);
 
END;
SELECT * FROM APPINVENTORY WHERE IDAPP = 'A8';
/**************************************************************************/
/*PROVA GESTI� CANVIS 1: INCREASECOUNTERS, DECREASECOUNTERS
/*Prova dels procediments auxiliars que actualitzen la taula Counters.
/**************************************************************************/
delete  from logtable;
delete  from counters ;
select * from counters ;
select * from logtable;

 --incrementar Counters
DECLARE
    RSP VARCHAR(200);
BEGIN
      increaseCounters('PA', '9999', RSP);
      DBMS_OUTPUT.put_line(RSP);
      increaseCounters('PA', '9999', RSP);
      DBMS_OUTPUT.put_line(RSP);
      increaseCounters('PA', '9999', RSP);
      DBMS_OUTPUT.put_line(RSP);
      increaseCounters('PA', '9999', RSP);
      DBMS_OUTPUT.put_line(RSP);

END;

--reduir valors counters
DECLARE
    RSP VARCHAR(200);
BEGIN
      --error: el concepte no existeix
      decreaseCounters('IE', '9999', RSP);
      DBMS_OUTPUT.put_line(RSP);
      --execucions correctes per reduir el valor
      decreaseCounters('PA', '9999', RSP);
      DBMS_OUTPUT.put_line(RSP);
      decreaseCounters('PA', '9999', RSP);
      DBMS_OUTPUT.put_line(RSP);
      decreaseCounters('PA', '9999', RSP);
      DBMS_OUTPUT.put_line(RSP);
      decreaseCounters('PA', '9999', RSP);
      DBMS_OUTPUT.put_line(RSP);
      --error: el valor ja �s 0 i no es pot reduir m�s
      decreaseCounters('PA', '9999', RSP);
      DBMS_OUTPUT.put_line(RSP);
END;

select * from counters;
select * from logtable;

/**************************************************************************
/*PROVA GESTI� CANVIS 2: CREATECHANGE, MODIFYCHANGE, DROPCHANGES
/*Crea categories i comprova que crear/modificar/eliminar canvis funciona ok.
/**************************************************************************/
delete from changes;
delete from logtable;
delete from counters where idcounter = 'PA' and yearinfo = '9999';
select * from changecategory;
select * from appinventory;
select * from geoareaapp;
select * from changes;
select * from logtable;

--crear categories 
DECLARE
    RSP VARCHAR(200);
BEGIN

    createChangeCategory( '1', '01/01/2010', '01/01/2010', '', RSP); DBMS_OUTPUT.put_line(RSP);
    createChangeCategory( '2', '01/01/2010', '01/01/2010', '', RSP); DBMS_OUTPUT.put_line(RSP);
    createChangeCategory( '3', '01/01/2010', '01/01/2010', '', RSP); DBMS_OUTPUT.put_line(RSP);
    createChangeCategory( '4', '01/01/2010', '01/01/2010', '', RSP); DBMS_OUTPUT.put_line(RSP);
    modifyChangeCategory( '4', '01/01/2020', '01/01/2020', '02/02/2021', RSP); DBMS_OUTPUT.put_line(RSP);
    dropChangeCategory('4', rsp); DBMS_OUTPUT.put_line(RSP);
    
END;

DECLARE
    RSP VARCHAR(200);
BEGIN
    --Error: aplicacio inexistent
    createChange('C0', 'Canvi 0', 'Descripcio', 'AA', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --crear canvi amb categoria 1 i geoscope high
    createChange('C1', 'Canvi 1', 'Descripcio', 'A1', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --crear canvi amb categoria 3 i geoscope low
    createChange('C2', 'Canvi 2', 'Descripcio', 'A2', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --canvi amb categoria 1 i geoscope low
    createChange('C3', 'Canvi 3', 'Descripcio', 'A6', RSP);
    DBMS_OUTPUT.put_line(RSP);
     --canvi amb categoria 2 i geoscope Medium
    createChange('C4', 'Canvi 4', 'Descripcio', 'A7', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --crear canvi amb categoria 1 i geoscope high
    createChange('C5', 'Canvi 5', 'Descripcio', 'A1', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --crear canvi amb categoria 3 i geoscope low
    createChange('C6', 'Canvi 6', 'Descripcio', 'A2', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --canvi amb categoria 1 i geoscope low
    createChange('C7', 'Canvi 7', 'Descripcio', 'A6', RSP);
    DBMS_OUTPUT.put_line(RSP);
     --canvi amb categoria 2 i geoscope Medium
    createChange('C8', 'Canvi 8', 'Descripcio', 'A7', RSP);
    DBMS_OUTPUT.put_line(RSP);
    createChange('C9', 'Canvi 9', 'Descripcio 9', 'A7', RSP);
    DBMS_OUTPUT.put_line(RSP);

    --modificar nom, descripcio i aplicacio d'un canvi. geoscope Medium i categoria 2
    modifyChange('C7', 'Canvi 7 modificat', 'Descripcio modificat', 'A7', RSP);
    DBMS_OUTPUT.put_line(RSP);

    --Eliminar canvi
    dropChange('C9', rsp);
    dbms_output.put_line(RSP);
END;

SELECT * FROM CHANGES;
select * from counters;
select * from logtable;


/**************************************************************************/
/*PROVA GESTIO CANVIS 3: MODIFYSTATUSCHANGE,
/*Comprova la modificacio de l'estat del canvi i la seva execucio
/**************************************************************************/
delete from logtable;
select * from changes;
select * from logtable;

DECLARE
    RSP VARCHAR(200);
BEGIN
   modifyStatusChange('C1','RE', RSP);
   dbms_output.put_line(RSP);
   modifyStatusChange('C2','AP', RSP);
   dbms_output.put_line(RSP);
   modifyStatusChange('C2','RE', RSP);
   dbms_output.put_line(RSP);

END;
select * from changes;
select * from logtable;

--**************************************************************************
--PROVA GESTIO CANVIS 4: INCREASECURRCHANGESTM, DECREASECURRCHANGESTM
--Comprova els procediments que actualitzen la taula TechnicalManagerData
/**************************************************************************/
DELETE FROM technicalmanagerdata;
select * from changes;
select * from technicalmanagerdata;
SELECT * FROM APPINVENTORY;
DECLARE
    RSP VARCHAR(200);
BEGIN
    DECREASECURRCHANGESTM('A1', RSP);
    DBMS_OUTPUT.put_line(RSP);
    INCREASECURRCHANGESTM('A1', RSP);
    DBMS_OUTPUT.put_line(RSP);
    INCREASECURRCHANGESTM('A1', RSP);
    DBMS_OUTPUT.put_line(RSP);
    DECREASECURRCHANGESTM('A1', RSP);
    DBMS_OUTPUT.put_line(RSP);
 
END;

DELETE FROM technicalmanagerdata;
select * from changes;
select * from technicalmanagerdata;
SELECT * FROM APPINVENTORY;
select * from counters;
DECLARE
    RSP VARCHAR(200);
BEGIN
    createChange('C100', 'Canvi 1', 'Descripcio', 'A1', RSP);
    DBMS_OUTPUT.put_line(RSP);
    modifyChange('C100', 'Canvi 100 modificat', 'Descripcio modificat', 'A2', RSP);
    DBMS_OUTPUT.put_line(RSP);
    dropchange('C100', rsp);
    DBMS_OUTPUT.put_line(RSP);

    INCREASECURRCHANGESTM('A1', RSP);
    DBMS_OUTPUT.put_line(RSP);
    INCREASECURRCHANGESTM('A2', RSP);
    DBMS_OUTPUT.put_line(RSP);
    INCREASECURRCHANGESTM('A6', RSP);
    DBMS_OUTPUT.put_line(RSP);
    INCREASECURRCHANGESTM('A7', RSP);
    DBMS_OUTPUT.put_line(RSP);
    
    INCREASECURRCHANGESTM('A1', RSP);
    DBMS_OUTPUT.put_line(RSP);
    INCREASECURRCHANGESTM('A2', RSP);
    DBMS_OUTPUT.put_line(RSP);
    INCREASECURRCHANGESTM('A7', RSP);
    DBMS_OUTPUT.put_line(RSP);
    INCREASECURRCHANGESTM('A7', RSP);
    DBMS_OUTPUT.put_line(RSP);

END;
/**************************************************************************/
/*PROVA GESTI� CANVIS 5: REJECTCHANGE APPROVECHANGE
/*Comprova el rebuig i aprovaci� de canvis
/**************************************************************************/
delete from logtable;
--delete from counters where idcounter = 'RE';
--DELETE FROM CHANGES WHERE STATUSCHANGE = 'RE';
select * from changes where statuschange = 'PA';
select * from logtable;
select * from counters ;

--Proves per rebutjar un canvi (rejectchange)
DECLARE
    RSP VARCHAR(200);
BEGIN
    --crear canvi amb categoria 1 i geoscope high
    createChange('C9', 'Canvi 9', 'Descripcio', 'A1', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --crear canvi amb categoria 3 i geoscope low
    createChange('C10', 'Canvi 10', 'Descripcio', 'A2', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --canvi amb categoria 1 i geoscope low
    createChange('C11', 'Canvi 11', 'Descripcio', 'A6', RSP);
    DBMS_OUTPUT.put_line(RSP);
     --canvi amb categoria 2 i geoscope Medium
    createChange('C12', 'Canvi 12', 'Descripcio', 'A7', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --rebutjar canvis creats
    rejectChange('C9', '2022', RSP);
    DBMS_OUTPUT.put_line(RSP);
    rejectChange('C10', '2022', RSP);
    DBMS_OUTPUT.put_line(RSP);
    rejectChange('C11', '2022', RSP);
    DBMS_OUTPUT.put_line(RSP);
    rejectChange('C12', '2023', RSP);
    DBMS_OUTPUT.put_line(RSP);

END;

select * from changes;
select * from logtable;
select * from counters where idcounter <> 'AP';

delete  from logtable;
SELECT * FROM APPINVENTORY;
SELECT * FROM MEMBERGCAB WHERE ROLEGCAB = 'CM';
--Proves per aprovar un canvi (approvechange, modifyapproval, dropapproval)
DECLARE
    RSP VARCHAR(200);
BEGIN
    --creem 8 canvis per tenir dades
    --crear canvi amb categoria 1 i geoscope high
    createChange('C13', 'Canvi 13', 'Descripcio', 'A1', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --aprovar i modificar el canvi
    approvechange('A1', 'C13', 'P3', '15/03/2023', 'Aprovacio TM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A1', 'C13', 'P5', '15/03/2023', 'Aprovacio BM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    modifyapproval('P5', 'C13', '01/06/2023', 'Aprovacio BM modificada', rsp);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A1', 'C13', 'P1', '15/03/2023', 'Aprovacio CM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    
    --crear canvi amb categoria 3 i geoscope low
    createChange('C14', 'Canvi 14', 'Descripcio', 'A2', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A2', 'C14', 'P7', '15/03/2023', 'Aprovacio TM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A2', 'C14', 'P9', '15/03/2023', 'Aprovacio BM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A2', 'C14', 'P1', '15/03/2023', 'Aprovacio CM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    
    --canvi amb categoria 1 i geoscope low
    createChange('C15', 'Canvi 15', 'Descripcio', 'A6', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A6', 'C15', 'P19', '15/03/2023', 'Aprovacio TM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A6', 'C15', 'P21', '15/03/2023', 'Aprovacio BM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A6', 'C15', 'P1', '15/03/2023', 'Aprovacio CM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    
     --canvi amb categoria 2 i geoscope Medium
    createChange('C16', 'Canvi 16', 'Descripcio', 'A7', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A7', 'C16', 'P19', '15/03/2023', 'Aprovacio TM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A7', 'C16', 'P21', '15/03/2023', 'Aprovacio BM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A7', 'C16', 'P1', '15/03/2023', 'Aprovacio CM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    
    --crear canvi amb categoria 1 i geoscope high
    createChange('C17', 'Canvi 17', 'Descripcio', 'A1', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A1', 'C17', 'P3', '15/03/2023', 'Aprovacio TM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A1', 'C17', 'P5', '15/03/2023', 'Aprovaciv BM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A1', 'C17', 'P1', '15/03/2023', 'Aprovacio CM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    
    --crear canvi amb categoria 3 i geoscope low
    createChange('C18', 'Canvi 18', 'Descripcio', 'A2', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A2', 'C18', 'P7', '15/03/2023', 'Aprovacio TM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A2', 'C18', 'P9', '15/03/2023', 'Aprovacio BM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A2', 'C18', 'P1', '15/03/2023', 'Aprovacio CM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    
    --canvi amb categoria 1 i geoscope low
    createChange('C19', 'Canvi 19', 'Descripcio', 'A6', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A6', 'C19', 'P19', '15/03/2023', 'Aprovacio TM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A6', 'C19', 'P21', '15/03/2023', 'Aprovacio BM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A6', 'C19', 'P1', '15/03/2023', 'Aprovacio CM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    
     --canvi amb categoria 2 i geoscope Medium  
    createChange('C20', 'Canvi 20', 'Descripcio', 'A7', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A7', 'C20', 'P19', '15/03/2023', 'Aprovacio TM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A7', 'C20', 'P21', '15/03/2023', 'Aprovacio BM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A7', 'C20', 'P1', '15/03/2023', 'Aprovacio CM', RSP);
    DBMS_OUTPUT.put_line(RSP);

END;

--prova dropapproval
DECLARE
    RSP VARCHAR(200);
BEGIN
    dropapproval('P1','C13', rsp);
    DBMS_OUTPUT.put_line(RSP);
    dropapproval('P3','C13', rsp);
    DBMS_OUTPUT.put_line(RSP);

end;

--prova que un substitut pugui aprovar un canvi
DECLARE
    RSP VARCHAR(200);
BEGIN
     --es crea, aprova i elimina un canvi 
    createChange('C100', 'Canvi test', 'Descripcio', 'A7', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --l'aprova el substitut
    approvechange('A7', 'C100', 'P20', '15/03/2023', 'Aprovacio TM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    dropapproval('P20','C100', rsp); DBMS_OUTPUT.put_line(RSP);
    DROPCHANGE('C100', RSP);DBMS_OUTPUT.put_line(RSP);
end;

select * from changes;
select * from logtable;
select * from counters;
select * from approval;

/**************************************************************************/
/*PROVA EXECUTAR CANVIS (AUXILIARS): UPDATEREPLANNEDCHANGES
/*INCREASECORRECTEXECUTIONSTM, DECREASECORRECTEXECUTIONSTM
/**************************************************************************/
--proves INCREASECORRECTEXECUTIONSTM/DECREASECORRECTEXECUTIONSTM
DELETE FROM LOGTABLE;
UPDATE TECHNICALMANAGERDATA SET CORRECTEXECUTIONS = 0;
delete from TECHNICALMANAGERDATA where technicalmanager = 'P11' or technicalmanager = 'P15';
SELECT * FROM TECHNICALMANAGERDATA; 
SELECT * FROM APPINVENTORY;
DECLARE
    RSP VARCHAR(200);
BEGIN
    --A3 t� TM amb id P11: Ha de quedar amb  1 execuci� correcta
    increaseCorrectExecutionsTM('A3', RSP);
    increaseCorrectExecutionsTM('A3', RSP);
    decreaseCorrectExecutionsTM('A3', RSP);
    --A4 t� TM amb id P15: Ha de quedar amb  0 execucions correctes
    decreaseCorrectExecutionsTM('A4', RSP);
    increaseCorrectExecutionsTM('A4', RSP);
    decreaseCorrectExecutionsTM('A4', RSP);
    decreaseCorrectExecutionsTM('A4', RSP);
END;
SELECT * FROM TECHNICALMANAGERDATA;
SELECT * FROM LOGTABLE;

--proves UPDATEREPLANNEDCHANGES
DELETE FROM REPLANNEDCHANGES;
DELETE FROM LOGTABLE;
select * from replannedchanges;
DECLARE
    RSP VARCHAR(200);
BEGIN
    --A1 t� les 4 �rees geogr�fiques
    updatereplannedchanges('A1', 'Total', 'Increase', rsp);
    updatereplannedchanges('A1', 'Total', 'Increase', rsp);
    updatereplannedchanges('A1', 'Total', 'Increase', rsp);
    updatereplannedchanges('A1', 'Total', 'Increase', rsp);
    updatereplannedchanges('A1', 'Replanned', 'Increase', rsp);
    updatereplannedchanges('A1', 'Replanned', 'Increase', rsp);
    updatereplannedchanges('A1', 'Replanned', 'Increase', rsp);
    updatereplannedchanges('A1', 'Replanned', 'Increase', rsp);
    updatereplannedchanges('A1', 'Replanned', 'Decrease', rsp);
    updatereplannedchanges('A1', 'Replanned', 'Decrease', rsp);
    updatereplannedchanges('A1', 'Total', 'Decrease', rsp);
    --A2 t� nom�s Europe
    updatereplannedchanges('A2', 'Replanned', 'Decrease', rsp);
    updatereplannedchanges('A2', 'Replanned', 'Decrease', rsp);
    updatereplannedchanges('A2', 'Replanned', 'Decrease', rsp);
    --Resultat esperat:
        --America, Asia, Oceania: 2x replanned, 3xtotal
        --Europa: 0 replanned, 3 total
        --Error al intentar reduir Europa, que ja est� a 0
END;
SELECT * FROM REPLANNEDCHANGES;
SELECT * FROM LOGTABLE;
select * from geoareaapp;
/**************************************************************************/
/*PROVA EXECUTAR CANVIS: EXECUTECHANGE, MODIFYEXECUTEDCHANGE, DROPEXECUTEDCHANGE
/**************************************************************************/
delete from TechnicalManagerData;
delete from ReplannedChanges;
delete from counters where idcounter = 'IE'; --Incorrect change;
delete from logtable;
select * from changes;
select * from approval;
select * from TechnicalManagerData;
select * from geoAreaApp;
select * from appinventory;
select * from executedchanges;
select * from counters;
select * from ReplannedChanges;
select * from logtable;

--Es creen i aproven 5x canvis per les proves: 
DECLARE
    RSP VARCHAR(200);
BEGIN
    /*Creem canvis amb �rees geogr�fiques diverses i diferents TM i BM 
    AX: �rees geogr�fiques             // (TM, BM)
    A1: Europe, America, Asia, Oceania // (P3, P5)
    A2: Europa                         // (P7, P9)
    A5: America, Asia, Oceania         // (P19, P21)
    A6: Asia                           // (P19, P21)
    A7: Asia, Oceania                  // (P19, P21)*/
    
    --canvi A1 amb Europa, Am�rica, Asia i Oceania // P3, P5
    createChange('C21', 'Canvi 21', 'Descripcio', 'A1', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A1', 'C21', 'P3', '15/03/2015', 'Aprovacio TM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A1', 'C21', 'P5', '15/03/2015', 'Aprovacio BM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A1', 'C21', 'P1', '15/03/2015', 'Aprovacio CM', RSP);
    DBMS_OUTPUT.put_line(RSP);

    --canvi amb A2 Europa// (P7, P9)
    createChange('C22', 'Canvi 22', 'Descripcio', 'A2', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A2', 'C22', 'P7', '15/03/2015', 'Aprovacio TM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A2', 'C22', 'P9', '15/03/2015', 'Aprovacio BM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A2', 'C22', 'P1', '15/03/2015', 'Aprovacio CM', RSP);
    DBMS_OUTPUT.put_line(RSP);

    --canvi amb A5 Am�rica, Asia i Oceania // P19, P21
    createChange('C23', 'Canvi 23', 'Descripcio', 'A5', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A5', 'C23', 'P19', '15/03/2015', 'Aprovacio TM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A5', 'C23', 'P21', '15/03/2015', 'Aprovacio BM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A5', 'C23', 'P1', '15/03/2015', 'Aprovacio CM', RSP);
    DBMS_OUTPUT.put_line(RSP);

    --canvi amb Asia // P19, P21
    createChange('C24', 'Canvi 24', 'Descripcio', 'A6', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A6', 'C24', 'P19', '15/03/2015', 'Aprovacio TM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A6', 'C24', 'P21', '15/03/2015', 'Aprovacio BM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A6', 'C24', 'P1', '15/03/2015', 'Aprovacio CM', RSP);
    DBMS_OUTPUT.put_line(RSP);

    --canvi amb Asia i Oceania // P19, P21
    createChange('C25', 'Canvi 25', 'Descripcio', 'A7', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A7', 'C25', 'P19', '15/03/2015', 'Aprovacio TM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A7', 'C25', 'P21', '15/03/2015', 'Aprovacio BM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A7', 'C25', 'P1', '15/03/2015', 'Aprovacio CM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    
END; 

delete from logtable;
DELETE FROM EXECUTEDCHANGES;
SELECT * FROM COUNTERS;
select * from changes;
select * from logtable;
select * from executedchanges;
select * from counters;
select * from TechnicalManagerData;
select * from ReplannedChanges;

--es prova l'execuci� de canvis executeChange
DECLARE
    RSP VARCHAR(200);
BEGIN
    --Error executar canvi no aprovat
    executeChange('C10', '15/02/2020', 'Correct', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --Executar canvi correcte / A1 Europa, Am�rica, Asia i Oceania
    executeChange('C21', '15/02/2020', 'Correct', RSP);
    DBMS_OUTPUT.put_line(RSP);
    -- A7, Asia i Oceania
    executeChange('C25', '15/02/2020', 'Correct', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --Error executar canvi ja executat correctament
    executeChange('C21', '15/02/2020', 'Correct', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --Executar canvi amb incid�ncies /A2, Europa
    executeChange('C22', '15/02/2020', 'Incidences', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --Executar canvi replanificat / A5, Europa, Am�rica, Asia i Oceania
    executeChange('C23', '15/02/2021', 'Replanned', RSP);
    DBMS_OUTPUT.put_line(RSP); 
    executeChange('C24', '15/02/2022', 'Replanned', RSP);  -- A6, Asia
    DBMS_OUTPUT.put_line(RSP);
END;

--es prova la modificaci� d'execucions modifyExecutedChanges
DECLARE
    RSP VARCHAR(200);
BEGIN
      --Canviar l'any d'execuci� incorrecta
        -- +1 a Counters IE per l'any anterior i +1 per l'any nou
        -- Resultat esperat: 0x2020 i 2x2021 i 1x2023
    modifyExecutedChange('C22', '15/02/2021', 'Incidences', rsp); DBMS_OUTPUT.put_line(RSP);
    modifyExecutedChange('C23', '15/02/2023', 'Replanned', rsp); DBMS_OUTPUT.put_line(RSP);
    --De incid�ncies a correcta: 
        --reduir -1 a Counters IE per any X
        --augmentar +1 execucions correctes pel TM (C22 t� TM P7)
        --Resultat esperat: 1x2021 a Counters. CorrectExecutions per P7: 1
    modifyExecutedChange('C22', '15/02/2021', 'Correct', rsp); DBMS_OUTPUT.put_line(RSP);
    --De correcta a Replanned:
        --augmentar +1 a Counters IE per any X
        --reduir -1 execucions correctes pel TM (TechnicalManagerData-correctExecutions )/P3
        --augmentar ReplannedExecutions-replanned per les �rees geogr�fiques / t� les 4
        --Resultat esperat: Counters 1x2020 / TechnicalManagerData-correctExecutions = 0 (P3)
        --              / 1xEuropa, 2xAmerica, 3xAsia, 2xOceania
    modifyExecutedChange('C21', '15/02/2020', 'Replanned', rsp); DBMS_OUTPUT.put_line(RSP);

END;

--es prova l'eliminaci� d'execucions dropExecutedChange
DECLARE
    RSP VARCHAR(200);
BEGIN
    --Eliminar canvi correcte (TM: P19 / AG: Asia, Oceania)
    dropExecutedChange('C25', RSP); DBMS_OUTPUT.put_line(RSP);
    --Eliminar canvi replanificat (TM: P19 / AG: Asia / 2022)
    dropExecutedChange('C24', RSP); DBMS_OUTPUT.put_line(RSP);

END;
 select * from counters where idcounter = 'IE';
 select * from technicalmanagerdata;
 SELECT * FROM replannedchanges;

/**************************************************************************/
/*PROVA PLANS D'ACCI� I ACCIONS: CREATEACTIONPLAN, MODIFYACTIONPLAN, DROPACTIONPLAN
/*CREATEACTION, MODIFYACTION, DROPACTION, UPDATEACTIONSINTIME, MODIFYACTIONDATE
/**************************************************************************/
delete from logtable;
delete from actionplan;
delete from counters where idcounter = 'OP';
select * from logtable;
select * from actionplan;
select * from counters where idcounter = 'OP';
select * from logtable;

--crear plans d'acci� createActionPlan
/***************************************/
DECLARE
    RSP VARCHAR(200);
BEGIN
    -- CREAR ACTION PLANS
    --ERROR: pla d'acci� per un canvi correcte (C22)
    createActionPlan('AP1', 'primer Action Plan', 'descripcio', '15/02/21', '15/08/21', 'C22', RSP); DBMS_OUTPUT.put_line(RSP);
    --ERROR: pla d'acci� d'un canvi no executat (C1)
    createActionPlan('AP1', 'primer Action Plan', 'descripcio', '15/02/21', '15/08/21', 'C1', RSP); DBMS_OUTPUT.put_line(RSP);
    --es creen dos plans d'acci� (canvis C21 i C23)
    createActionPlan('AP1', 'primer Action Plan', 'descripcio', '15/02/20', '15/08/20', 'C21', RSP); DBMS_OUTPUT.put_line(RSP);
    createActionPlan('AP2', 'segon Action Plan', 'descripcio', '15/02/23', '15/08/23', 'C23', RSP); DBMS_OUTPUT.put_line(RSP);
    -- ERROR: No es pot eliminar una execuci� si hi ha pla d'acci� creat
    dropExecutedChange('C23', RSP); DBMS_OUTPUT.put_line(RSP);

END;
delete from logtable;
select * from logtable;
select * from actionplan;
select * from counters where idcounter = 'OP';
select * from logtable;

delete from logtable;
delete from action;
select * from action; 
select * from logtable;
--crear i modificar accions: createActions i modifyActions
/***********************************************************/
DECLARE
    RSP VARCHAR(200);
BEGIN
      -- ACTIONS
      createAction('AT1', 'AP1', 'Accio 1 pla 1', 'descripcio', rsp); DBMS_OUTPUT.put_line(RSP);
      createAction('AT2', 'AP1', 'Accio 1 pla 1', 'descripcio', rsp); DBMS_OUTPUT.put_line(RSP);     
      createAction('AT1', 'AP2', 'Accio 1 pla 2', 'descripcio', rsp); DBMS_OUTPUT.put_line(RSP);
      createAction('AT2', 'AP2', 'Accio 1 pla 2', 'descripcio', rsp); DBMS_OUTPUT.put_line(RSP);
      modifyAction('AT2', 'AP2', 'AT2AP2 modif', 'descripcio modif', rsp); DBMS_OUTPUT.put_line(RSP);

END;

delete from logtable;
delete from actionsintime;
select * from logtable;
select * from actionsintime;

--auxiliar updateActionsInTime
/******************************/
DECLARE
    RSP VARCHAR(200);
BEGIN
    updateActionsInTime(sysdate, 'InTime', 'Decrease', rsp); --error
    updateActionsInTime(sysdate, 'InTime', 'Increase', rsp);
    updateActionsInTime(sysdate, 'InTime', 'Decrease', rsp);
    updateActionsInTime(sysdate, 'InTime', 'Decrease', rsp); --error
    updateActionsInTime(sysdate, 'InTime', 'Increase', rsp);
    updateActionsInTime(sysdate, 'InTime', 'Increase', rsp);
    updateActionsInTime(sysdate, 'InTime', 'Increase', rsp);
    updateActionsInTime(sysdate, 'InTime', 'Increase', rsp); --total: 4
    
    updateActionsInTime(sysdate, 'Total', 'Decrease', rsp); --error
    updateActionsInTime(sysdate, 'Total', 'Increase', rsp);
    updateActionsInTime(sysdate, 'Total', 'Decrease', rsp);
    updateActionsInTime(sysdate, 'Total', 'Decrease', rsp); --error
    updateActionsInTime(sysdate, 'Total', 'Increase', rsp);
    updateActionsInTime(sysdate, 'Total', 'Increase', rsp);
    updateActionsInTime(sysdate, 'Total', 'Increase', rsp);
    updateActionsInTime(sysdate, 'Total', 'Increase', rsp); --total: 4
    
END;
-- informar data d'una acci� (realitzar/desfer acci�) modifyActionDate
/***********************************************************/
delete from logtable; delete from actionsINTime;
select * from logtable;
select * from actionsintime;
select * from action;
DECLARE
    RSP VARCHAR(200);
BEGIN
    -- ACTIONS
    --Dins termini: informa data i +1 a ActionsINTime-inTime/Total
    modifyActionDate('AT1','AP1','20/03/2021', RSP);DBMS_OUTPUT.put_line(RSP);
    modifyActionDate('AT2','AP1','20/03/2021', RSP);DBMS_OUTPUT.put_line(RSP);
    --Fora termini: informa data i +1 a ActionsINTime-Total
    modifyActionDate('AT1','AP2','20/12/2023', RSP);DBMS_OUTPUT.put_line(RSP);
    modifyActionDate('AT2','AP2','20/12/2023', RSP);DBMS_OUTPUT.put_line(RSP);
    --Desfer acci� dins termini: esborra data i -1 a ActionsINTime-inTime/Total
    modifyActionDate('AT2','AP1','', RSP);DBMS_OUTPUT.put_line(RSP);
    --Desfer acci� fora termini: esborra data i -1 a ActionsINTime-Total
    modifyActionDate('AT2','AP2','', RSP);DBMS_OUTPUT.put_line(RSP);
   
    
END;

--modificar plans d'acci�  modifyActionPlan
/***********************************************************/
delete from logtable; 
delete from actionsINTime;
select * from logtable;
select * from actionsintime;
select * from actionplan;
select * from action;
select * from technicalmanagerdata;
select * from counters where idcounter = 'OP';
DECLARE
    RSP VARCHAR(200);
BEGIN
    --ERROR: el nou canvi s'ha executat correctament
    modifyActionPlan('AP1', 'primer Action Plan modif', 'descripcio modif', 'F', '15/02/21', '15/08/21', 'C22', RSP); DBMS_OUTPUT.put_line(RSP);
    --ERROR: el pla no t� accions i no es pot tancar
    modifyActionPlan('AP1', 'primer AP', 'descripcio modif', 'T', '15/02/21', '15/08/21', 'C23', RSP); DBMS_OUTPUT.put_line(RSP);
    --ERROR: el pla t� accions obertes i no es pot tancar
    modifyActionPlan('AP1', 'primer AP', 'descripcio modif', 'T', '15/02/21', '15/08/21', 'C23', RSP); DBMS_OUTPUT.put_line(RSP);
   
    --tancar les accions dels plans (inTime)
     modifyActionDate('AT2','AP1','15/05/2021', RSP);DBMS_OUTPUT.put_line(RSP);
     modifyActionDate('AT2','AP2','15/05/2023', RSP);DBMS_OUTPUT.put_line(RSP);
    --Tancar un pla obert (Counters OP -1 / TechnicalManagerData-currChanges pel TM -1 /P3)
     modifyActionPlan('AP1', 'primer AP', 'descripcio modif', 'T', '15/02/21', '15/08/21', 'C21', RSP); 
     DBMS_OUTPUT.put_line(RSP);
     modifyActionPlan('AP2', 'segon Action Plan', 'descripcio','T', '15/02/23', '15/08/23', 'C23', RSP); 
     DBMS_OUTPUT.put_line(RSP);   
--    --Obrir un pla tancat (Counters OP +1 / TechnicalManagerData-currChanges pel TM +1
     modifyActionPlan('AP2', 'segon Action Plan', 'descripcio','F', '15/02/23', '15/08/23', 'C23', RSP);
     DBMS_OUTPUT.put_line(RSP);  

END;
SELECT * FROM ACTIONPLAN;

--TODOeliminar accions i plans d'acció. dropAction, dropActionPlan
/***********************************************************/
delete from logtable; 
select * from logtable;
select * from actionsintime;
select * from actionplan;
select * from action;
select * from technicalmanagerdata;
select * from counters where idcounter = 'OP';
DECLARE
    RSP VARCHAR(200);
BEGIN
     --ERROR: el pla d'acci no es pot eliminar, est tancat
     dropActionPlan('AP1', RSP);DBMS_OUTPUT.put_line(RSP); 
     --ERROR: el pla d'acci no es pot eliminar, t accions
     dropActionPlan('AP2', RSP);DBMS_OUTPUT.put_line(RSP);  
     --ERROR: el pla està tancat i l'acció no es pot eliminar
     dropAction('AT1', 'AP1', rsp);DBMS_OUTPUT.put_line(RSP);  
--    --Eliminar acció finalitzada dins el termini
       --ActionsInTime-inTime/Total - 1
       --s'elimina acció d'Actions
     dropAction('AT2', 'AP2', rsp);DBMS_OUTPUT.put_line(RSP);
     --eliminar acci fora de termini
     dropAction('AT1', 'AP2', rsp);DBMS_OUTPUT.put_line(RSP);
    -- Eliminar pla d'acció
       --S'elimina d'ActionPlan
       --Counters OP -1
       dropActionPlan('AP2',RSP);DBMS_OUTPUT.put_line(RSP);
END;
SELECT * FROM ACTIONPLAN;
/**************************************************************************/
/*PROVA BREACHES 1: CREATEBREACH, MODIFYBREACH, DROPBREACH
/**************************************************************************/
delete from LOGTABLE;
delete from breaches;
SELECT * FROM LOGTABLE;
select * from BREACHES;
select * from counters where idcounter = 'BR';
DECLARE
    RSP VARCHAR(200);
BEGIN
    createBreach('B1', 'primera Breach', 'C1', 'description', '25/02/2023', 'OK', RSP);
    DBMS_OUTPUT.put_line(RSP);
    modifyBreach('B1', '1a Breach modificada', 'C2', 'description', '25/11/2023', 'KO', RSP);
    DBMS_OUTPUT.put_line(RSP);
    createBreach('B2', 'segona Breach', 'A2', 'description', '25/12/2023', 'OK', RSP);
    DBMS_OUTPUT.put_line(RSP);
    createBreach('B3', 'tercera Breach', 'A3', 'description', '10/04/2023', 'KO', RSP);
    DBMS_OUTPUT.put_line(RSP);
    createBreach('B4', 'quarta Breach', 'A4', 'description', '10/12/2023', 'KO', RSP);
    DBMS_OUTPUT.put_line(RSP);
    createBreach('B5', '5a Breach', 'C4', 'description', '10/04/2023', 'KO', RSP);
    DBMS_OUTPUT.put_line(RSP);
    createBreach('B6', '6a Breach', 'C5', 'description', '10/12/2023', 'KO', RSP);
    DBMS_OUTPUT.put_line(RSP);
    createBreach('B7', '7a Breach', 'C6', 'description', '10/04/2023', 'KO', RSP);
    DBMS_OUTPUT.put_line(RSP);
    createBreach('B8', '8a Breach', 'C6', 'description', '10/12/2023', 'OK', RSP);
    DBMS_OUTPUT.put_line(RSP);
    createBreach('B9', '9a Breach', 'A7', 'description', '10/04/2023', 'OK', RSP);
    DBMS_OUTPUT.put_line(RSP);
    createBreach('B10', '10a Breach', 'A6', 'description', '10/12/2023', 'KO', RSP);
    DBMS_OUTPUT.put_line(RSP);
    createBreach('B11', '11a Breach', 'A3', 'description', '10/04/2023', 'OK', RSP);
    DBMS_OUTPUT.put_line(RSP);
    dropBreach('B11', RSP);
    DBMS_OUTPUT.put_line(RSP);
    --Resultat: 10 Breaches creades, una modificada (B1). 
    --amb aquestes dades: 4 incompliments en els �ltims 6 mesos
END;
SELECT * FROM LOGTABLE;
select * from BREACHES;
/**************************************************************************/
/*PROVA BREACHES 2: PROCEDIMENT AUXILIAR UPDATEBREACHES
/**************************************************************************/
delete from LOGTABLE;
delete from breaches;
delete from counters where idcounter = 'BR';
SELECT * FROM LOGTABLE;
select * from BREACHES;
select * from counters;
DECLARE
    RSP VARCHAR(200);
BEGIN
    --Resultat amb les dades anteriors: 4 incompliments en els �ltims 6 mesos
    updatesNumberBreaches(RSP);
END;
SELECT * FROM LOGTABLE;
select * from BREACHES;
select * from counters;
/**************************************************************************/
/*PROVA SUBSTITUTIONS 1: PROCEDIMENT AUXILIAR UPDATEUNPLANNEDSUBSTITUTIONS
/**************************************************************************/
delete from LOGTABLE;
delete from unplannedsubstitutions;
SELECT * FROM LOGTABLE;
select * from unplannedsubstitutions;
select * from membergcab;
DECLARE
    RSP VARCHAR(200);
BEGIN
    updateUnplannedSubstitutions('P1', 'Increase', RSP);
    DBMS_OUTPUT.put_line(RSP);
    updateUnplannedSubstitutions('P1', 'Increase', RSP);
    DBMS_OUTPUT.put_line(RSP);
    updateUnplannedSubstitutions('P1', 'Increase', RSP);
    DBMS_OUTPUT.put_line(RSP);
    updateUnplannedSubstitutions('P1', 'Decrease', RSP);
    DBMS_OUTPUT.put_line(RSP);
    updateUnplannedSubstitutions('P3', 'Decrease', RSP);
    DBMS_OUTPUT.put_line(RSP);
    updateUnplannedSubstitutions('P3', 'Increase', RSP);
    DBMS_OUTPUT.put_line(RSP);
    updateUnplannedSubstitutions('P3', 'Decrease', RSP);
    DBMS_OUTPUT.put_line(RSP);
    updateUnplannedSubstitutions('P3', 'Decrease', RSP);
    DBMS_OUTPUT.put_line(RSP);
END;
SELECT * FROM LOGTABLE;
select * from unplannedsubstitutions;
/**************************************************************************/
/*PROVA SUBSTITUTIONS 2: CREATE, MODIFY, DROP SUBSTITUTIONS
/**************************************************************************/
delete from logtable;
delete from substitutions;
delete from unplannedSubstitutions;
select * from logtable;
select * from substitutions;
select * from unplannedSubstitutions;

DECLARE
    RSP VARCHAR(200);
BEGIN
--    CREATESUBSTITUTION (planificades)
--    crear 5x substitucions planificada
    createSubstitution('P11', '01/02/2010', 'T', 'Vacances', '01/03/2010', rsp); DBMS_OUTPUT.put_line(RSP);
    createSubstitution('P13', '01/02/2010', 'T', 'Vacances', '01/03/2010', rsp);DBMS_OUTPUT.put_line(RSP);
    createSubstitution('P15', '01/02/2010', 'T', 'Vacances', '01/03/2010', rsp);DBMS_OUTPUT.put_line(RSP);
    createSubstitution('P19', '01/02/2010', 'T', 'Vacances', '01/03/2010', rsp);DBMS_OUTPUT.put_line(RSP);
    createSubstitution('P21', '01/02/2010', 'T', 'Vacances', '01/03/2010', rsp);DBMS_OUTPUT.put_line(RSP);   
    --crear 11x substitucions no planificada / +1 unplanned
    createSubstitution('P19', '03/03/2011', 'F', 'Malaltia', '05/03/2011', rsp); DBMS_OUTPUT.put_line(RSP);
    createSubstitution('P19', '03/04/2011', 'F', 'Malaltia', '05/04/2011', rsp); DBMS_OUTPUT.put_line(RSP);
    createSubstitution('P19', '03/05/2011', 'F', 'Malaltia', '05/05/2011', rsp); DBMS_OUTPUT.put_line(RSP);
    createSubstitution('P3', '03/03/2011', 'F', 'Malaltia', '05/03/2011', rsp); DBMS_OUTPUT.put_line(RSP);
    createSubstitution('P3', '03/04/2011', 'F', 'Malaltia', '05/04/2011', rsp); DBMS_OUTPUT.put_line(RSP);
    createSubstitution('P3', '03/05/2011', 'F', 'Malaltia', '05/05/2011', rsp);DBMS_OUTPUT.put_line(RSP);
    createSubstitution('P3', '03/06/2011', 'F', 'Malaltia', '05/06/2011', rsp); DBMS_OUTPUT.put_line(RSP);
    createSubstitution('P3', '03/07/2011', 'F', 'Malaltia', '05/07/2011', rsp); DBMS_OUTPUT.put_line(RSP);
    createSubstitution('P3', '03/08/2011', 'F', 'Malaltia', '05/08/2011', rsp); DBMS_OUTPUT.put_line(RSP);
    createSubstitution('P7', '03/04/2011', 'F', 'Malaltia', '05/04/2011', rsp); DBMS_OUTPUT.put_line(RSP);
    createSubstitution('P7', '03/05/2011', 'F', 'Malaltia', '05/05/2011', rsp); DBMS_OUTPUT.put_line(RSP);
    --Resultat: aprovador amb més unplanned subst: P3 (6 unplannedSubst)
    
    --MODIFYSUBSTITUTION
    --modif subst de planificada a no planificada
    modifySubstitution('P11', '01/02/2010', 'F', 'Vacances modif', '11/02/2010', rsp); DBMS_OUTPUT.put_line(RSP);
  --modif subsd de no planificada a planificada
    modifySubstitution('P11', '01/02/2010', 'T', 'Vacances modif', '11/02/2010', rsp); DBMS_OUTPUT.put_line(RSP);

    --DROPSUBSTITUTION
    --esborrar substit planificada
    dropSubstitution('P21', '01/02/2010',rsp);DBMS_OUTPUT.put_line(RSP);  
    --esborrar substit no planificada
    dropSubstitution('P7', '03/05/2011',rsp);DBMS_OUTPUT.put_line(RSP);
    --Resultat: aprovador amb més unplanned subst: P3 (6 unplannedSubst)
  
END;
DELETE FROM SUBSTITUTIONS;
DELETE FROM UNPLANNEDSUBSTITUTIONS;
DELETE FROM LOGTABLE;
SELECT * FROM LOGTABLE;
SELECT * FROM MEMBERGCAB;
SELECT * FROM SUBSTITUTIONS;
SELECT * FROM UNPLANNEDSUBSTITUTIONS;

/**************************************************************************/
/*AFEGIR DADES EXTRES PER LES CONSULTES
/**************************************************************************/

-- Aprovar canvis per 2023 i 2024
DECLARE
    RSP VARCHAR(200);
BEGIN
    ---canvis C3, C4, C7 i C8 per 2024
    approvechange('A6', 'C3', 'P19', '05/01/2024', 'Aprovacio TM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A6', 'C3', 'P21', '05/01/2024', 'Aprovacio BM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A6', 'C3', 'P1', '05/01/2024', 'Aprovacio CM', RSP);
    DBMS_OUTPUT.put_line(RSP);

    approvechange('A7', 'C4', 'P19', '05/01/2024', 'Aprovacio TM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A7', 'C4', 'P21', '05/01/2024', 'Aprovacio BM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A7', 'C4', 'P1', '05/01/2024', 'Aprovacio CM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    
    approvechange('A7', 'C7', 'P19', '05/01/2024', 'Aprovacio TM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A7', 'C7', 'P21', '05/01/2024', 'Aprovacio BM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A7', 'C7', 'P1', '05/01/2024', 'Aprovacio CM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    
    approvechange('A7', 'C8', 'P19', '05/01/2024', 'Aprovacio TM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A7', 'C8', 'P21', '05/01/2024', 'Aprovacio BM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A7', 'C8', 'P1', '05/01/2024', 'Aprovacio CM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    
    --canvis C1, C2, C5, C6 per 2023
    approvechange('A1', 'C1', 'P3', '05/01/2023', 'Aprovacio TM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A1', 'C1', 'P5', '05/01/2023', 'Aprovacio BM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A1', 'C1', 'P1', '05/01/2023', 'Aprovacio CM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    
    approvechange('A2', 'C2', 'P7', '05/01/2023', 'Aprovacio TM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A2', 'C2', 'P9', '05/01/2023', 'Aprovacio BM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A2', 'C2', 'P1', '05/01/2023', 'Aprovacio CM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    
    approvechange('A1', 'C5', 'P3', '05/01/2023', 'Aprovacio TM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A1', 'C5', 'P5', '05/01/2023', 'Aprovacio BM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A1', 'C5', 'P1', '05/01/2023', 'Aprovacio CM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    
    approvechange('A2', 'C6', 'P7', '05/01/2023', 'Aprovacio TM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A2', 'C6', 'P9', '05/01/2023', 'Aprovacio BM', RSP);
    DBMS_OUTPUT.put_line(RSP);
    approvechange('A2', 'C6', 'P1', '05/01/2023', 'Aprovacio CM', RSP);
    DBMS_OUTPUT.put_line(RSP);
  
END;

----Executar canvis correctament i incorrectament. 
DECLARE
    RSP VARCHAR(200);
BEGIN
    --Executar incorrectament pel 2023
    executeChange('C1', '15/02/2023', 'Incidences', RSP); DBMS_OUTPUT.put_line(RSP);
    executeChange('C2', '15/02/2023', 'Incidences', RSP); DBMS_OUTPUT.put_line(RSP);
    executeChange('C5', '15/02/2023', 'Incidences', RSP); DBMS_OUTPUT.put_line(RSP);
    executeChange('C6', '15/02/2023', 'Incidences', RSP); DBMS_OUTPUT.put_line(RSP);

    --Executar correctament pel 2024
    executeChange('C3', '15/02/2024', 'Correct', RSP); DBMS_OUTPUT.put_line(RSP);
    executeChange('C4', '15/02/2024', 'Correct', RSP); DBMS_OUTPUT.put_line(RSP);
    executeChange('C7', '15/02/2024', 'Correct', RSP); DBMS_OUTPUT.put_line(RSP);
    executeChange('C8', '15/02/2024', 'Correct', RSP); DBMS_OUTPUT.put_line(RSP);
END;


----Crear plans d'acci per les execucions incorrectes
DECLARE
    RSP VARCHAR(200);
BEGIN
    --Plans d'acci pels canvis C1, C2, C5, C6
    createActionPlan('AP2', 'segon AP',  'descripcio', '15/02/23', '15/08/23', 'C1', RSP); DBMS_OUTPUT.put_line(RSP);
    createActionPlan('AP3', 'tercer AP', 'descripcio', '15/02/23', '15/08/23', 'C2', RSP); DBMS_OUTPUT.put_line(RSP);
    createActionPlan('AP4', 'quart AP',  'descripcio', '15/02/23', '15/08/23', 'C5', RSP); DBMS_OUTPUT.put_line(RSP);
    createActionPlan('AP5', 'cinque AP', 'descripcio', '15/02/23', '15/08/23', 'C6', RSP); DBMS_OUTPUT.put_line(RSP);
    
END;

----Crear accions pels plans d'acci
DECLARE
    RSP VARCHAR(200);
BEGIN
    
    createAction('AT1', 'AP2', 'Accio 1 pla 2', 'descripcio', rsp); DBMS_OUTPUT.put_line(RSP);
    createAction('AT2', 'AP2', 'Accio 2 pla 2', 'descripcio', rsp); DBMS_OUTPUT.put_line(RSP);
    
    createAction('AT1', 'AP3', 'Accio 1 pla 3', 'descripcio', rsp); DBMS_OUTPUT.put_line(RSP);
    createAction('AT2', 'AP3', 'Accio 2 pla 3', 'descripcio', rsp); DBMS_OUTPUT.put_line(RSP);
    
    createAction('AT1', 'AP4', 'Accio 1 pla 4', 'descripcio', rsp); DBMS_OUTPUT.put_line(RSP);
    createAction('AT2', 'AP4', 'Accio 2 pla 4', 'descripcio', rsp); DBMS_OUTPUT.put_line(RSP);
    
    createAction('AT1', 'AP5', 'Accio 1 pla 5', 'descripcio', rsp); DBMS_OUTPUT.put_line(RSP);
    createAction('AT2', 'AP5', 'Accio 2 pla 5', 'descripcio', rsp); DBMS_OUTPUT.put_line(RSP);

END;


----Finalitzar les accions fora i dins del termini
DECLARE
    RSP VARCHAR(200);
BEGIN

    modifyActionDate('AT1','AP2','20/03/2023', RSP);DBMS_OUTPUT.put_line(RSP);
    modifyActionDate('AT2','AP2','20/03/2023', RSP);DBMS_OUTPUT.put_line(RSP);
    
    modifyActionDate('AT1','AP3','20/11/2023', RSP);DBMS_OUTPUT.put_line(RSP);
    modifyActionDate('AT2','AP3','20/11/2023', RSP);DBMS_OUTPUT.put_line(RSP);
    
    modifyActionDate('AT1','AP4','20/11/2023', RSP);DBMS_OUTPUT.put_line(RSP);
    modifyActionDate('AT2','AP4','20/11/2023', RSP);DBMS_OUTPUT.put_line(RSP);
    
    modifyActionDate('AT1','AP5','20/11/2023', RSP);DBMS_OUTPUT.put_line(RSP);
    modifyActionDate('AT2','AP5','20/11/2023', RSP);DBMS_OUTPUT.put_line(RSP);
END;


----Crear ms canvis, que quedin en estat en procs d'aprovaci
DECLARE
    RSP VARCHAR(200);
BEGIN

    modifyActionDate('AT1','AP2','20/03/2023', RSP);DBMS_OUTPUT.put_line(RSP);
    modifyActionDate('AT2','AP2','20/03/2023', RSP);DBMS_OUTPUT.put_line(RSP);
    
    modifyActionDate('AT1','AP3','20/11/2023', RSP);DBMS_OUTPUT.put_line(RSP);
    modifyActionDate('AT2','AP3','20/11/2023', RSP);DBMS_OUTPUT.put_line(RSP);
    
    modifyActionDate('AT1','AP4','20/11/2023', RSP);DBMS_OUTPUT.put_line(RSP);
    modifyActionDate('AT2','AP4','20/11/2023', RSP);DBMS_OUTPUT.put_line(RSP);
    
    modifyActionDate('AT1','AP5','20/11/2023', RSP);DBMS_OUTPUT.put_line(RSP);
    modifyActionDate('AT2','AP5','20/11/2023', RSP);DBMS_OUTPUT.put_line(RSP);
END;
 